#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>

#define TAG 1

int main(int argc, char ** argv) {

//Two arguments here, the first, N, is the size of the array.
//N should be a multiple of world_size for this first attempt....
//The second is the range, R, of the random numbers.

	int my_rank, world_size;
	int my_sum = 0;
	int total_sum = 0;
	float my_avg;
	float total_avg;

        char message[256], name[80];
        MPI_Status status;

	int j, k;
        int N = atoi(argv[1]);
	int R = atoi(argv[2]);

	int seed;
	double rand1 = 0.0;
	double temp = 0.0;
	seed = time(NULL);
	srand(seed);

	MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	int NewN = 0;
	int SubN = N/world_size;

	NewN = ((int)(N/world_size+1))*world_size;

	int *RandomArray = NULL;
	int *SubArray = NULL;
	float *SubAvgs = NULL;

	if (my_rank == 0)
	{
		SubAvgs = (float *)malloc(world_size * sizeof(int));
		RandomArray = (int *)malloc(2 * N * sizeof(int));
		printf("Node %d: N is %d, SubN is %d. Now populating the random array. \n", my_rank, N, SubN);
		for(k=0; k<N; k++)
		{
			rand1 = rand();
			temp = rand1 / (double) RAND_MAX;
			RandomArray[k] = R*temp;
//			RandomArray[k] = -R + 2*R*temp;
		}
		printf("Node %d: First entry is %d, last entry is %d. \n", my_rank, RandomArray[0], RandomArray[N-1]);
	}
	
	if (my_rank > -1)
	{
		SubArray = (int *)malloc(SubN * sizeof(int));
		SubArray[0] = -1;
		SubArray[SubN-1] = 1;
		for(k=1; k < SubN-1; k++)
		{
			SubArray[k] = 0;
		}
		printf("Node %d: SubN is %d, entry 0 is %d, entry %d is %d. \n", my_rank, SubN, SubArray[0], SubN-1, SubArray[SubN-1]);
	}

	MPI_Scatter(RandomArray, SubN, MPI_INT, SubArray, SubN, MPI_INT, 0, MPI_COMM_WORLD);

	if (my_rank > -1)
	{
		printf("Node %d: Received data. SubN is %d, entry 0 is %d, entry %d is %d. \n", my_rank, SubN, SubArray[0], SubN-1, SubArray[SubN-1]);
	}
	for(k=0; k<SubN; k++)
	{
		my_sum = my_sum + SubArray[k];
	}
	my_avg = my_sum/(float)SubN;
	printf("Node %d: My SubArray sum is %d, and the average is %4.4f \n", my_rank, my_sum, my_avg);

	MPI_Gather(&my_avg, 1, MPI_FLOAT, SubAvgs, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);

	if (my_rank == 0)
	{
		for(k=0; k<world_size; k++)
		{
			printf("Node %d: Average from node %d is %4.4f \n", my_rank, k, SubAvgs[k]);
		}
	}


//		my_sum = my_sum+j;	
//	}
//	
//
//	if (my_rank ==0)
//	{
//		printf("\n");
//		for(k=0; k<world_size; k++)
//		{
//			printf("Node %d's numbers summed to %d \n", k, PartialSums[k]);
//		}
//		for(k=0; k<world_size; k++)
//		{
//			total_sum = total_sum+PartialSums[k];
//		}
//		printf("Node %d: The total sum is %d\n", my_rank, total_sum);
//	}


    MPI_Finalize();

}
